Name:          struts
Version:       1.3.10
%define subrel 2
Release:       %mkrel 8
Summary:       Web application framework
Group:         Development/Java
License:       ASL 2.0
URL:           http://struts.apache.org/
# wget http://www.apache.org/dist/struts/source/struts-1.3.10-src.zip
# remove non free resources
# unzip -qq struts-1.3.10-src.zip
# rm -r struts-1.3.10/src/core/src/main/resources/org/apache/struts/resources/web-app_2_3.dtd
# tar czf struts-1.3.10-clean-src.tar.gz struts-1.3.10
Source0:       %{name}-%{version}-clean-src.tar.gz

# fix build for junit servlet-3.0-api
Patch1:        %{name}-%{version}-fix-build.patch
# Thanks to Arun Babu Neelicattu aneelica@redhat.com
# and Brandon.Vincent@asu.edu
Patch2:        struts-1.3.10-CVE-2014-0114.patch
Patch3:        struts-1.3.10-CVE-2015-0899.patch
Patch4:        struts-1.3.10-CVE-2016-1181-CVE-2016-1182.patch
Patch5:        struts-1.3.10-Xdoclint.patch

BuildArch:     noarch

BuildRequires: maven-local
BuildRequires: mvn(antlr:antlr)
BuildRequires: mvn(commons-beanutils:commons-beanutils)
BuildRequires: mvn(commons-chain:commons-chain)
BuildRequires: mvn(commons-digester:commons-digester)
BuildRequires: mvn(commons-fileupload:commons-fileupload)
BuildRequires: mvn(commons-logging:commons-logging)
BuildRequires: mvn(commons-validator:commons-validator)
BuildRequires: mvn(junit:junit)
BuildRequires: mvn(log4j:log4j:1.2.17)
BuildRequires: mvn(org.apache.bsf:bsf)
BuildRequires: mvn(org.jboss.spec.javax.el:jboss-el-api_3.0_spec)
BuildRequires: mvn(org.jboss.spec.javax.faces:jboss-jsf-api_2.2_spec)
BuildRequires: mvn(org.jboss.spec.javax.servlet.jsp:jboss-jsp-api_2.3_spec)
BuildRequires: mvn(org.jboss.spec.javax.servlet:jboss-servlet-api_3.1_spec)
BuildRequires: mvn(org.jboss.spec.javax.servlet.jstl:jboss-jstl-api_1.2_spec)
BuildRequires: mvn(oro:oro)

Obsoletes:     %{name}-manual < %{version}
Obsoletes:     %{name}-webapps-tomcat5 < %{version}

%description
Welcome to the Struts Framework! The goal of this project is to provide
an open source framework useful in building web applications with Java
Servlet and JavaServer Pages (JSP) technology. Struts encourages
application architectures based on the Model-View-Controller (MVC)
design paradigm, colloquially known as Model 2 in discussions on various
servlet and JSP related mailing lists.
Struts includes the following primary areas of functionality:
A controller servlet that dispatches requests to appropriate Action
classes provided by the application developer.
JSP custom tag libraries, and associated support in the controller
servlet, that assists developers in creating interactive form-based
applications.
Utility classes to support XML parsing, automatic population of
JavaBeans properties based on the Java reflection APIs, and
internationalization of prompts and messages.

%package       javadoc
Summary:       Javadoc for %{name}
Group:         Documentation

%description   javadoc
This package contains javadoc for %{name}.

%prep
%setup -q
find -name "*.jar" -delete
find -name "*.class" -delete

%patch1 -p1
%patch2 -p0
%patch3 -p1
%patch4 -p1
%patch5 -p1

sed -i 's/\r//' LICENSE.txt NOTICE.txt

# fix non ASCII chars
for s in src/tiles/src/main/java/org/apache/struts/tiles/ComponentDefinition.java;do
  native2ascii -encoding UTF8 ${s} ${s}
done

cd src

%pom_remove_parent

%pom_change_dep -r :servlet-api org.jboss.spec.javax.servlet:jboss-servlet-api_3.1_spec:1.0.0.Beta1
%pom_change_dep -r :jstl org.jboss.spec.javax.servlet.jstl:jboss-jstl-api_1.2_spec:1.0.3.Final
%pom_remove_dep -r taglibs:standard

%pom_change_dep -r :jsp-api org.jboss.spec.javax.servlet.jsp:jboss-jsp-api_2.3_spec:1.0.0.Beta1
%pom_change_dep -r :myfaces-jsf-api org.jboss.spec.javax.faces:jboss-jsf-api_2.2_spec:2.2.0
%pom_change_dep -r :bsf org.apache.bsf:

# package javax.el does not exist
%pom_add_dep org.jboss.spec.javax.servlet.jsp:jboss-jsp-api_2.3_spec:1.0.0.Beta1 core

%mvn_file :%{name}-core %{name}/core
%mvn_file :%{name}-el %{name}/el
%mvn_file :%{name}-extras %{name}/extras
%mvn_file :%{name}-faces %{name}/faces
%mvn_file :%{name}-mailreader-dao %{name}/mailreader-dao
%mvn_file :%{name}-scripting %{name}/scripting
%mvn_file :%{name}-taglib %{name}/taglib
%mvn_file :%{name}-tiles %{name}/tiles

%build

cd src
%mvn_build -- -Dproject.build.sourceEncoding=UTF-8

%install

(
cd src
%mvn_install
)

%files -f src/.mfiles
%dir %{_javadir}/%{name}
%dir %{_mavenpomdir}/%{name}
%doc LICENSE.txt NOTICE.txt

%files javadoc -f src/.mfiles-javadoc
%doc LICENSE.txt NOTICE.txt


%changelog
* Wed Jun 22 2016 daviddavid <daviddavid> 1.3.10-8.2.mga5
+ Revision: 1037231
- add patch4 to fix CVE-2016-1181 and CVE-2016-1182 (mga#18763)
- add patch5 to fix javadoc build on JDK 8 (disabling the super-strict doclint checks)
- sync with fc22 (fix CVE-2015-0899) (mga#16601)
- fix owner of maven-poms dir

* Thu Jan 08 2015 daviddavid <daviddavid> 1.3.10-8.mga5
+ Revision: 809463
- Sync with fc21

  + umeabot <umeabot>
    - Second Mageia 5 Mass Rebuild
    - Mageia 5 Mass Rebuild

* Tue May 13 2014 luigiwalser <luigiwalser> 1.3.10-5.mga5
+ Revision: 622476
- rediff patch from redhat to fix CVE-2014-0114

* Fri Oct 18 2013 umeabot <umeabot> 1.3.10-4.mga4
+ Revision: 519154
- Mageia 4 Mass Rebuild

* Mon Jan 14 2013 umeabot <umeabot> 1.3.10-3.mga3
+ Revision: 383567
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Mon Sep 10 2012 dmorgan <dmorgan> 1.3.10-2.mga3
+ Revision: 291923
- Add jboss support

* Mon Dec 05 2011 gil <gil> 1.3.10-1.mga2
+ Revision: 176919
- added tomcat6 as BR
- fix requires servlet
- build fix
  used tomcat 6.x apis
  added patch2
- correct depmap
- update to 1.3.10

* Sat Mar 19 2011 dmorgan <dmorgan> 0:1.2.9-10.mga1
+ Revision: 74348
- Do not package tomcat3 files
- Do not package tomcat3 files

* Fri Mar 18 2011 dmorgan <dmorgan> 0:1.2.9-9.mga1
+ Revision: 74341
- Do not package tomcat4 package

* Fri Mar 18 2011 dmorgan <dmorgan> 0:1.2.9-8.mga1
+ Revision: 74252
- Remove gcj support

* Fri Jan 21 2011 dmorgan <dmorgan> 0:1.2.9-7.12.mga1
+ Revision: 27815
- Adapt for mageia
- Adapt for mageia
- imported package struts


* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0:1.2.9-7.12
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Fri Jun 19 2009 David Walluck <dwalluck@redhat.com> 0:1.2.9-6.12
- Resolves: CVE-2008-2025

* Wed Feb 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0:1.2.9-6.11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Thu Jul 10 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 0:1.2.9-5.11
- drop repotag

* Thu May 29 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 0:1.2.9-5jpp.10
- fix license tag

* Mon Feb 18 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 0:1.2.9-5jpp.9
- Autorebuild for GCC 4.3

* Thu Sep 27 2007 Deepak Bhole <dbhole@redhat.com> 1.2.9-4jpp.9
- Re-enable compliation of webapp classes, and disable run of check-buildroot

* Mon Sep 24 2007 Deepak Bhole <dbhole@redhat.com> 1.2.9-4jpp.8
- Exclude webapp classes from native compilation (issues with check-build-root)

* Thu Sep 20 2007 Deepak Bhole <dbhole@redhat.com> 1.2.9-4jpp.7
- Rebuild for ppc32 execmem issue and new build-id
- Add %%{?dist} as per new policy

* Tue Mar 27 2007 Deepak Bhole <dbhole@redhat.com> 1.2.9-4jpp.6
- Rewrote pre/preun/post/postun dependencies
- Change Pre[rR]eq -> Requires(pre)
- Add unowned directory to folders section. bz# 233821.

* Wed Aug 30 2006 Deepak Bhole <dbhole@redhat.com> 1.2.9-4jpp.2
- Rebuilding.

* Fri Aug 25 2006 Deepak Bhole <dbhole@redhat.com> - 0:1.2.9-4jpp.1
- Fix requirements

* Tue Aug 22 2006 Fernando Nasser <fnasser@redhat.com> - 0:1.2.9-3jpp.1
- Merge with upstream for upgrade to 1.2.9
- Use symlinks instead of actual files in WEB-INF/lib folders
- Add conditional native compilation

* Tue Aug 22 2006 Fernando Nasser <fnasser@redhat.com> - 0:1.2.9-3jpp
- Remove duplicate macros
- Fix removal of old struts-el documentation link
- Create coreonly option

* Thu Apr 06 2006 Ralph Apel <r.apel@r-apel.de> - 0:1.2.9-2jpp
- Switch to _javadir/cactus-14/*.jar
- Thus require cactus >= 1.7.1-2jpp

* Wed Mar 29 2006 Ralph Apel <r.apel@r-apel.de> - 0:1.2.9-1jpp
- Upgrade to 1.2.9

* Thu Oct 20 2005 Ralph Apel <r.apel@r-apel.de> - 0:1.2.7-2jpp
- Add struts-chain subpackages
- Add struts-el subpackages
- Add struts-faces subpackages

* Tue Jul 26 2005 Fernando Nasser <fnasser@redhat.com> - 0:1.2.7-1jpp
- Upgrade to 1.2.7

* Fri May 27 2005 Gary Benson <gbenson@redhat.com> - 0:1.2.4-2jpp
- Build with servletapi5.
- Add build dependency on ant-nodeps.

* Tue Feb  1 2005 Joe Orton <jorton@redhat.com>
- Change webapps subpackages' tomcat dependencies to prereqs.

* Fri Nov 26 2004 Fernando Nasser <fnasser@redhat.com> - 0:1.2.4-1jpp
- Upgrade to 1.2.4

* Sat Sep 04 2004 Fernando Nasser <fnasser@redhat.com> - 0:1.1-3jpp
- Rebuilt with Ant 1.6.2

* Sat Jan 10 2004 Kaj J. Niemi <kajtzu@fi.basen.net> - 0:1.1-2jpp
- Fixed runtime requires
- Fix examples by making symlinks work in their respective (sub-)directories,
  the template comes for tomcat4 from Source #2 and for tomcat5 from Source #3

* Fri Jan  9 2004 Kaj J. Niemi <kajtzu@fi.basen.net> - 0:1.1-1jpp
- Updated to 1.1
- Use tomcat4 real webapps dir instead of -compat provided app dir
- To compile against < JDK 1.4 jdkmajorver needs to be set to 1.3

* Tue Mar 25 2003 Nicolas Mailhot <Nicolas.Mailhot (at) JPackage.org> 1.0.2-4jpp
- for jpackage-utils 1.5

* Thu Mar 28 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.0.2-3jpp 
- fixed incorrect files in manual package

* Wed Mar 27 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.0.2-2jpp 
- corrected URL
- cleaned webapps
- tagged webapps

* Sun Mar 24 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.0.2-1jpp 
- 1.0.2
- generic servlet support
- distinct webapps for tomcat3 and tomcat4
- no duplicate files for webapps
- correct file ownership for webapps

* Wed Jan 23 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.0-4jpp
- section macro
- versioned dir for javadoc
- no dependencies for manual and javadoc packages
- stricter dependencies for webapp package
- requires tomcat3
- no more requires servlet3 as tomcat3 requires it
- requires and buildrequires xalan-j2 >= 2.2.0
- adaptation to new servlet3 package
- adaptation to new xalan-j2 package
- adapation to new tomcat3 package
- uncompressed webapps

* Wed Dec 5 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.0-3jpp
- javadoc into javadoc package

* Tue Nov 20 2001 Christian Zoffoli <czoffoli@littlepenguin.org> 1.0-2jpp
- removed packager tag
- new jpp extension
- added xalan 2.2.D13 support

* Thu Nov 1 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.0-1jpp
- first JPackage release
